diff --git a/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.c b/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.c
new file mode 100644
index 0000000..8347b88
--- /dev/null
+++ b/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.c
@@ -0,0 +1,119 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_MIC9404x.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   MIC9404x test function.
+ *
+ * @param[in] stream  Stream for input/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestMic9404xFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_mic9404data_t*)test->data)->driver != NULL);
+
+  // local variables
+  mic9404x_lld_state_t state_orig;
+  mic9404x_lld_state_t state;
+  aos_testresult_t result = {0, 0};
+  uint32_t status = APAL_STATUS_OK;
+
+  chprintf(stream, "reading current status...\n");
+  status = mic9404x_lld_get(((aos_test_mic9404data_t*)test->data)->driver, &state_orig);
+  if (status == APAL_STATUS_OK) {
+    aosTestPassedMsg(stream, &result, "power %s\n", (state_orig == MIC9404x_LLD_STATE_ON) ? "enabled" : "disabled");
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  state = state_orig;
+  for (uint8_t i = 0; i < 2; ++i) {
+    if (state == MIC9404x_LLD_STATE_ON) {
+      chprintf(stream, "disabling for five seconds...\n");
+      status = mic9404x_lld_set(((aos_test_mic9404data_t*)test->data)->driver, MIC9404x_LLD_STATE_OFF);
+      status |= mic9404x_lld_get(((aos_test_mic9404data_t*)test->data)->driver, &state);
+      if (state == MIC9404x_LLD_STATE_OFF) {
+        aosThdSSleep(5);
+        status |= mic9404x_lld_get(((aos_test_mic9404data_t*)test->data)->driver, &state);
+      }
+      if ((status == APAL_STATUS_OK) && (state == MIC9404x_LLD_STATE_OFF)) {
+        aosTestPassed(stream, &result);
+      } else {
+        aosTestFailed(stream, &result);
+        break;
+      }
+    } else {
+      chprintf(stream, "enabling for five seconds...\n");
+      status = mic9404x_lld_set(((aos_test_mic9404data_t*)test->data)->driver, MIC9404x_LLD_STATE_ON);
+      status |= mic9404x_lld_get(((aos_test_mic9404data_t*)test->data)->driver, &state);
+      if (state == MIC9404x_LLD_STATE_ON) {
+        aosThdSSleep(5);
+        status |= mic9404x_lld_get(((aos_test_mic9404data_t*)test->data)->driver, &state);
+      }
+      if ((status == APAL_STATUS_OK) && (state == MIC9404x_LLD_STATE_ON)) {
+        aosTestPassed(stream, &result);
+      } else {
+        aosTestFailed(stream, &result);
+        break;
+      }
+    }
+  }
+  // restore original state
+  if (state != state_orig) {
+    status = mic9404x_lld_set(((aos_test_mic9404data_t*)test->data)->driver, state);
+    if (status != APAL_STATUS_OK) {
+      chprintf(stream, "\t\tWARNING: failed to restore original status!\n");
+    }
+  }
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(MIC9404xDriver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.h b/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.h
new file mode 100644
index 0000000..4df8694
--- /dev/null
+++ b/test/periphery-lld/MIC9404x_v1/aos_test_MIC9404x.h
@@ -0,0 +1,77 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_MIC9404x_H
+#define AMIROOS_TEST_MIC9404x_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_MIC9404x.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the driver to use.
+   */
+  MIC9404xDriver* driver;
+
+} aos_test_mic9404data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestMic9404xFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_MIC9404x_H */
diff --git a/test/periphery-lld/MPR121_v1/aos_test_MPR121.c b/test/periphery-lld/MPR121_v1/aos_test_MPR121.c
new file mode 100644
index 0000000..343f4e1
--- /dev/null
+++ b/test/periphery-lld/MPR121_v1/aos_test_MPR121.c
@@ -0,0 +1,187 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_MPR121.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+#define INTERRUPT_EVENT_ID            1
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestMpr121Func(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_mpr121data_t*)test->data)->mprd != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+  mpr121_lld_config_t cfg;
+  uint8_t data = 0;
+  uint8_t wdata = 0;
+  uint8_t rdata = 0;
+  uint16_t edata[4] = {0};
+  uint8_t tstate = 0;
+  event_listener_t event_listener;
+  aos_timestamp_t tstart, tcurrent, tend;
+
+  chprintf(stream, "soft reset...\n");
+  status = mpr121_lld_soft_reset(((aos_test_mpr121data_t*)test->data)->mprd, ((aos_test_mpr121data_t*)test->data)->timeout);
+  status |= mpr121_lld_read_config(((aos_test_mpr121data_t*)test->data)->mprd, &cfg, ((aos_test_mpr121data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && cfg.registers.ele_config == 0) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "read register...\n");
+  status = mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_2, 0, 1, &data, ((aos_test_mpr121data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tdata: 0x%02X\n", data);
+  if (status == APAL_STATUS_SUCCESS && data == (MPR121_LLD_CDT_0_5 | MPR121_LLD_ESI_16)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "write register...\n");
+  wdata = MPR121_LLD_CDT_32 | MPR121_LLD_SFI_10 | MPR121_LLD_ESI_16;
+  status = mpr121_lld_write_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_2, 0, 1, &wdata, ((aos_test_mpr121data_t*)test->data)->timeout);
+  aosThdMSleep(500);
+  status |= mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_2, 0, 1, &rdata, ((aos_test_mpr121data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tdata: 0x%02X\n", rdata);
+  status |= mpr121_lld_write_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_2, 0, 1, &data, ((aos_test_mpr121data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && rdata == wdata) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "read config...\n");
+  status = mpr121_lld_read_config(((aos_test_mpr121data_t*)test->data)->mprd, &cfg, ((aos_test_mpr121data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && cfg.registers.config_1 == 0x10 && cfg.registers.config_2 == 0x24) {
+    aosTestPassed(stream, &result);
+  } else {
+    chprintf(stream, "\t\tconfig 1: 0x%02X\n", cfg.registers.config_1);
+    chprintf(stream, "\t\tconfig 2: 0x%02X\n", cfg.registers.config_2);
+    mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_1, 0, 1, &rdata, ((aos_test_mpr121data_t*)test->data)->timeout);
+    chprintf(stream, "\t\tconfig 1: 0x%02X\n", rdata);
+    mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_CONFIG_2, 0, 1, &rdata, ((aos_test_mpr121data_t*)test->data)->timeout);
+    chprintf(stream, "\t\tconfig 2: 0x%02X\n", rdata);
+    for (uint8_t valueIdx = 0; valueIdx < 8; valueIdx++) {
+      chprintf(stream, "\t\tdata %d: 0x%02X\n", valueIdx, cfg.values[valueIdx]);
+    }
+    chprintf(stream, "ele_config: 0x%02X\n", cfg.registers.ele_config);
+    chprintf(stream, "config_1: 0x%02X\n", cfg.registers.config_1);
+    chprintf(stream, "config_2: 0x%02X\n", cfg.registers.config_2);
+    chprintf(stream, "target_level: 0x%02X\n", cfg.registers.target_level);
+    chprintf(stream, "low_side_limit: 0x%02X\n", cfg.registers.low_side_limit);
+    chprintf(stream, "up_side_limit: 0x%02X\n", cfg.registers.up_side_limit);
+    chprintf(stream, "auto_config_2: 0x%02X\n", cfg.registers.auto_config_2);
+    chprintf(stream, "auto_config_1: 0x%02X\n", cfg.registers.auto_config_1);
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "write config...\n");
+  cfg.registers.ele_config = MPR121_LLD_CL_ON_ALL | MPR121_LLD_ELEPROX_0 | 4;
+  cfg.registers.config_1 = MPR121_LLD_FFI_18 | 16;
+  cfg.registers.config_2 = MPR121_LLD_CDT_1 | MPR121_LLD_SFI_10 | MPR121_LLD_ESI_32;
+  cfg.registers.up_side_limit = 0x96u;
+  cfg.registers.low_side_limit = 0x58u;
+  cfg.registers.target_level = 0x68u;
+  cfg.registers.auto_config_1 = MPR121_LLD_FFI_18 | MPR121_LLD_RETRY_2 | MPR121_LLD_BVA_ON_ALL | MPR121_LLD_AC_RECONF_EN;
+  status = mpr121_lld_write_config(((aos_test_mpr121data_t*)test->data)->mprd, cfg, ((aos_test_mpr121data_t*)test->data)->timeout);
+  aosThdMSleep(500);
+  status |= mpr121_lld_read_config(((aos_test_mpr121data_t*)test->data)->mprd, &cfg, ((aos_test_mpr121data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && cfg.registers.up_side_limit == 0x96u) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "read filtered data for ten seconds...\n");
+  chprintf(stream, "(values should change if you touch the sensors now)\n");
+  for (uint8_t i = 0; i < 10; i++) {
+    status = mpr121_lld_read_filtered_data(((aos_test_mpr121data_t*)test->data)->mprd, 0, 4, edata, ((aos_test_mpr121data_t*)test->data)->timeout);
+    chprintf(stream, "\t\t0x%04X | 0x%04X | 0x%04X | 0x%04X\n", edata[0], edata[1], edata[2], edata[3]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  chprintf(stream, "test interrupts...\n");
+  status = AOS_OK;
+  chEvtRegister(((aos_test_mpr121data_t*)test->data)->evtsource, &event_listener, INTERRUPT_EVENT_ID);
+  aosSysGetUptime(&tstart);
+  tend = tstart + (30 * MICROSECONDS_PER_SECOND);
+  do {
+    aosSysGetUptime(&tcurrent);
+    const aos_timestamp_t ttimeout = MICROSECONDS_PER_SECOND - ((tcurrent - tstart) % MICROSECONDS_PER_SECOND);
+    const eventmask_t emask = chEvtWaitOneTimeout(EVENT_MASK(INTERRUPT_EVENT_ID), chTimeUS2I(ttimeout));
+    const eventflags_t eflags = chEvtGetAndClearFlags(&event_listener);
+    if (emask == EVENT_MASK(INTERRUPT_EVENT_ID) && eflags == ((aos_test_mpr121data_t*)test->data)->evtflags) {
+      // interrupt detected
+      status |= mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_TOUCH_STATUS, 0, 1, &tstate, ((aos_test_mpr121data_t*)test->data)->timeout);
+      chprintf(stream, "\t\tinterrupt detected\n");
+      chprintf(stream, "\t\ttstate: %X %X %X %X\n", tstate & 1, (tstate >> 1) & 1, (tstate >> 2) & 1, (tstate >> 3) & 1);
+    }
+    else if (emask == 0) {
+      // timeout
+      status |= mpr121_lld_read_register(((aos_test_mpr121data_t*)test->data)->mprd, MPR121_LLD_REGISTER_TOUCH_STATUS, 0, 1, &tstate, ((aos_test_mpr121data_t*)test->data)->timeout);
+      chprintf(stream, "\t\ttstate: %X %X %X %X\n", tstate & 1, (tstate >> 1) & 1, (tstate >> 2) & 1, (tstate >> 3) & 1);
+    }
+    aosSysGetUptime(&tcurrent);
+  } while (tcurrent < tend);
+  chEvtUnregister(((aos_test_mpr121data_t*)test->data)->evtsource, &event_listener);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X\n", status);
+  }
+
+  aosTestInfoMsg(stream,"driver object memory footprint: %u bytes\n", sizeof(MPR121Driver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/MPR121_v1/aos_test_MPR121.h b/test/periphery-lld/MPR121_v1/aos_test_MPR121.h
new file mode 100644
index 0000000..30cf936
--- /dev/null
+++ b/test/periphery-lld/MPR121_v1/aos_test_MPR121.h
@@ -0,0 +1,91 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_MPR121_H
+#define AMIROOS_TEST_MPR121_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_MPR121.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   Pointer to the MPR121 driver to use.
+   */
+  MPR121Driver* mprd;
+
+  /**
+   * @brief   Timeout value (in us).
+   */
+  apalTime_t timeout;
+
+  /**
+   * @brief   Event source to listen to.
+   */
+  event_source_t* evtsource;
+
+  /**
+   * @brief   Event flags to watch.
+   */
+  eventflags_t evtflags;
+} aos_test_mpr121data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestMpr121Func(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_MPR121_H */
diff --git a/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.c b/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.c
new file mode 100644
index 0000000..dc0d56a
--- /dev/null
+++ b/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.c
@@ -0,0 +1,65 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_MPU6050.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestMpu6050Func(BaseSequentialStream* stream, const aos_test_t* test)
+{
+    aos_testresult_t result = {0, 0};
+
+    uint8_t data[1] = {0};
+    int32_t status = 0;
+
+    status = mpu6050_lld_read_register(((aos_test_mpu6050data_t*)test->data)->mpu, MPU6050_LLD_WHO_AM_I, data, 1, ((aos_test_mpu6050data_t*)test->data)->timeout);
+    if (status == APAL_STATUS_OK && data[0] == MPU6050_I_AM) {
+      aosTestPassed(stream, &result);
+    } else {
+      aosTestFailedMsg(stream, &result, "0x%08X | 0x%02X\n", status, data[0]);
+    }
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.h b/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.h
new file mode 100644
index 0000000..ecae056
--- /dev/null
+++ b/test/periphery-lld/MPU6050_v1/aos_test_MPU6050.h
@@ -0,0 +1,81 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_MPU6050_H
+#define AMIROOS_TEST_MPU6050_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_MPU6050.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   MPU6050 driver to use.
+   */
+  MPU6050Driver *mpu;
+
+  /**
+   * @brief   Timeout delay for certain tests.
+   */
+  apalTime_t timeout;
+} aos_test_mpu6050data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestMpu6050Func(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_MPU6050_H */
